org 0h

        push cs
        pop ds

        mov ax, 35FEh           ; Get Some Info
        int 21h
        mov [dataseg], es
        mov [dataoff], bx
        mov si, bx

        mov WORD es:[si], 07eh  ; Function 07Eh - Get centerpos
        mov WORD es:[si+2], 86  ; 86px. width
        int 0FFh
        mov ax, es:[si+4]
        mov [logopos], ax       ; Store logo in logopos

        ; Then get the desktop-applications
;        jmp paintme
aloop:
;    xor dx, dx
    ; At first convert the number
        mov WORD es:[si], 0eh       ; Function 0eh - inttostr
        mov dx, [runnum]            ; Get number
        inc dx                      ; Raise it
        mov es:[si+2], dx
        mov [runnum], dx
        dec dx
        mov es:[si+4], cs           ; Store segment
        mov WORD es:[si+6], runnumstr ; Store offset
        mov WORD es:[si+8], 10      ; Bufferlen
        int 0FFh                    ; DO it!
                    ; Then get the setting
        mov WORD es:[si], 0bh       ; Function 0bh - get setting
        mov es:[si+2], cs           ; Store segment
        mov WORD es:[si+4], runstr  ; Store offset
        int 0FFh                    ; DO it!

        mov bx, dx
        shl bx, 2                   ; BX=DX*4
        mov ax, es:[si+6]           ; Get segment
        mov [progstr+bx+2], ax
        mov ax, es:[si+8]           ; Offset
        mov [progstr+bx], ax

        cmp dx, 9               ; Through?
        jnz aloop               ; No: Again

;        jmp paintme            ; Paint this proggie

mainexecloop:

        ; ----

        mov WORD es:[si], 9     ; Function 9h - kbhit?
        int 0FFh
        mov ax, es:[si+2]
        cmp ax, 0
        jnz kbhit               ; Yes -> Jmp kbhit

        mov WORD es:[si], 3     ; Function 3h - Get last signal
        mov WORD es:[si+2], 0ffh ; Get own signal
        int 0FFh                ; DO that!
        mov ax, es:[si+4]
        cmp ax, 1               ; Signal 1 (Paint)?
        jz dopaintme
        cmp ax, 2               ; Signal 2 (Term)?
        jz quitme

        ; ----
dotswitch:                      
        int 0FCh
        push cs
        pop ds
        mov es, [dataseg]
        mov si, [dataoff]
        jmp mainexecloop
dopaintme: jmp paintme
quitme:
        mov WORD es:[si], 0     ; Function 0 - Kill
        mov es:[si+2], cs       ; Store CS
        int 0FFh                ; DO that (bye,bye)
            ; Still there? Let's do a taskswitch
whynokill: int 0FCh
            ; Really killed. If not: hang in a quit-loop
        jmp quitme

kbhit:
        mov WORD es:[si], 0ah   ; Function a - getch
        int 0FFh
        mov ax, es:[si+2]       ; Get it in AL

        or al, 32               ; Make lowercase
        cmp al, 'q'             ; q(uit)
        jz quitme
        cmp al, 'k'             ; k(ill os)
        jnz donotkillme
        mov bx, killme
        jmp bx
donotkillme:
        cmp al, '1'
        jb dotswitch
        cmp al, '9'
        jnbe dotswitch
            ; Range 1-9 - We have to execute....
        xor ah, ah              ; 8Bit -> 16Bit
        dec al, '1'             ; String -> Number (single digit)
        shl ax, 2               ; *4
        mov bx, ax              ; Put in BX for adressing

        mov WORD es:[si], 0fh   ; Function fh - execute
        mov ax, [progstr+bx]    ; Offset
        mov es:[si+4], ax
        mov ax, [progstr+bx+2]  ; Segment
        mov es:[si+2], ax
        int 0FFh                ; DO It!
        jmp dotswitch           ; Let's make a taskswitch

dokillme: mov bx, killme
          jmp bx
    
paintme:
        mov WORD es:[si], 82h   ; Function 82h - Display
        mov WORD es:[si+2], 5   ; SubFunction 5h - paint rectangle
        mov WORD es:[si+4], 0FFFFh ; FFFFh - Paint entire rectangle
        mov WORD es:[si+12], 14 ; Color 14
        int 0FFh                ; DO that!


        mov WORD es:[si], 82h   ; Function 82h - Display
        mov WORD es:[si+2], 7h  ; SubFunction 7h - Draw sprite
        mov ax, cs:[logopos]    ; Get the X
        mov es:[si+4], ax
        mov WORD es:[si+6], 10  ; Y=10
        mov es:[si+8], cs       ; Segment
        mov WORD es:[si+10], bmsprite   ; Offset
        int 0FFh                ; DO that!

        push si
        mov di, si              ; Transfer Functiondataa
        mov si, msgdata
        mov cx, 7
        cld
        rep movsw
        pop si
        mov es:[si+14], cs      ; Store segment
        mov WORD es:[si+16], msgs ; Store offset
        int 0FFh                ; Do it

    ; Now print the base-proggies
        
        ; Header
        mov WORD es:[si+16], prognam ; Store offset
        mov WORD es:[si+4], 350 ; Store X
        int 0FFh

        mov WORD es:[si+4], 366 ; Store X
        xor cx, cx
dploop:
        mov bx, cx              ; Get the pos
        shl bx, 2               ; BX=CX*4
        mov ax, [progstr+bx]    ; Offset
        mov es:[si+16], ax
        mov ax, [progstr+bx+2]  ; Segment
        mov es:[si+14], ax
        int 0FFh                ; DO it!

        mov ax, es:[si+6]       ; Get Y
        add ax, 16              ; +8
        mov es:[si+6], ax       ; Put Y
        inc cx                  ; Next one
        cmp cx, 10              ; Finished?
        jnz dploop              ; No -> Again
        
        jmp dotswitch
; ------

killme:
        xor ax, ax              ; 0=KILL-Shutdown
doashutdown:
        mov es:[si+2], ax
        mov WORD es:[si], 8     ; Function 8
        int 0FFh
        int 0FCh

dataseg dw 0
dataoff dw 0
logopos dw 0

msgdata: dw 82h,6,10,50,9,-1,1       ; Fkt82h,SubFkt.6,X=10,Y=50,FG=0,BG=-1,Font=1
msgs:
        db 'Welcome to Ulsop!',10
        db ' Press Q to quit this program',10
        db ' Press K to kill the os (fast shutdown)',10
        db 10
        db 10
        db 'Have a nice day :-)',0
prognam:    db '1=',10,'2=',10,'3=',10,'4=',10,'5=',10,'6=',10,'7=',10,'8=',10,'9=',0
progstr:    dd 9 dup 0
runstr:     db 'DESK'
runnumstr:  db '0000',0
runnum      dw 0

bmsprite:
    db '                     AA',10
    db '                     AA',10
    db 'AA             AA    AA',10
    db 'AA             AA    AA',10
    db 'AA             AA    AA',10
    db 'AA             AA    AA',10
    db 'AA             AA    AA',10
    db 'AA             AA    AA                                A',10
    db 'AA             AA    AA                               AA',10
    db 'AA             AA    AA                    AAAAA      AA',10
    db 'AA             AA    AA       AAAAAA     AAAAAAAA     AAAAAAAA',10
    db 'AA             A     AA     AAAAAAAAA   AAA    AAA   AAAAAAAAAAAA',10
    db 'AA             A     AA     AA     AA   AA      AAA  AAA       AAA',10
    db 'AA            AA     AA    AA           AA       AA   AA         AA',10
    db 'AA            AA     AA    AA          AA        AA   AA         AA',10
    db ' A            AA     AA    AA          AA        AA   AA          AA',10
    db ' AA           AA     AA    AAAAAAAAA   AA        AA   AA          AA',10
    db ' AA           AA     AA     AAAAAAAAA  AA        AA   AA          AA',10
    db ' AA          AA      AA            AA  AA       AA    AA          AA',10
    db ' AA          AA      AA            AA  AAA     AAA    AAAA      AAA',10
    db '  AA        AA       AA            AA   AAA   AAA     AA AAAAAAAAAA',10
    db '  AAA     AAAA       AA  AA       AAA   AAAAAAAA      AA  AAAAAAA',10
    db '   AAAAAAAAA         AA  AAA     AAA      AAAA        AA',10
    db '     AAAAA               AAAAAAAAAA                   AA',10
    db '                           AAAAAA                     AA',10
    db '                                                      AA',10
    db '                                                      AA',10
    db '                                                      AA',10
    db '                                                      AA',10
    db '                                                      AA',10
    db '                                                      AA',0
