; fast320 - driver for 1024x768x8 direct vram-access (SVGA)

    jmp startme
dstrt:
    cmp ah, cs:[mydrvid]
    jnz retjmp

    cmp al, 0
    jz retdata
    cmp al, 1
    jz retmode
    cmp al, 2
    jz setmode
    cmp al, 3
    jz setpixel
;    cmp al, 4
;    jz getpixel
    cmp al, 0FFh
    jz freemem

    mov ax, 0FFFFh
    mov bx, 0FFFFh
    mov cx, 0FFFFh
    mov dx, 0FFFFh
    iret

retjmp: jmp 0FFFFh:0000h

setpixel:       ; CX,DX = BL
setpixel:
    push ax
    push bx
    push cx
    push dx
    push es
    push di

    mov ax, 0A000h
    mov es, ax

    mov di, dx
    mov ax, 1024
    mul di          ; AX*DI=(DX:)AX

    ; Don't forget the X
    add ax, cx
    jno addrok
    inc dx
addrok:

        ; Now we have the bank in DX and the offset in AX
        
;    cmp dx, cs:[curbank]
;    jz nobankset
;    mov cs:[curbank], dx

    push ax
    push bx
    mov ax, 4F05h           ; Switch bank (bank in dx)
    xor bx, bx
    int 10h
    pop bx
    pop ax

;    push ax
;    mov cl, dl

;    mov dx, 3d4h
;    mov al, 35h
;    out dx, al
    
;    mov dx, 3d5h
;    in al, dx
;    and al, 0F0h
;    or al, cl
;    out dx, al
;    pop ax

nobankset:
    mov di, ax
    mov es:[di], bl

    pop di
    pop es
    pop dx
    pop cx
    pop bx
    pop ax
    iret

setmode:
        mov ax, 4F02h
        mov bx, 105h        ; Mode 105
        int 10h
        iret

retmode:
        mov ax, 1024
        mov bx, 768
        mov cx, 8
        iret

retdata:
        xor ah, ah
        mov al, 1
        iret

freemem:
    mov ax, 3
    int 10h

    mov ax, cs
    xor bx, bx
    xor cx, cx
    xor dx, dx
    mov si, 1234h
    iret

curbank dw 0FFFFh
mydrvid db 0

nop
startme:
        mov ax, [02ch]          ; Get enviroment
        mov es, ax
        mov ah, 49h             ; Free...
        int 21h                 ; ...memory

    mov ax, 35FDh
    int 21h
    mov ax, es
    mov [retjmp+1], bx
    mov [retjmp+3], ax

    mov ax, 25FDh
    mov dx, dstrt
    int 21h

    mov ax, 35FEh
    int 21h
    mov ax, es:[bx]
    mov [mydrvid], al

    mov dx, startme
    int 27h
