    jmp startme
dstrt:
    cmp ah, cs:[mydrvid]
    jnz retjmp

    cmp al, 0
    jz retdata
    cmp al, 1
    jz retmode
    cmp al, 2
    jz setmode
    cmp al, 3
    jz setpixel
    cmp al, 4
    jz getpixel
    cmp al, 0FFh
    jz freemem

    mov ax, 0FFFFh
    mov bx, 0FFFFh
    mov cx, 0FFFFh
    mov dx, 0FFFFh
    iret

retjmp: jmp 0FFFFh:0000h

freemem:
    mov ax, 3
    int 10h

    mov ax, cs
    xor bx, bx
    xor cx, cx
    xor dx, dx
    mov si, 1234h
    iret

retdata:
    xor ah, ah
    mov al, 7
    iret

setmode:
    add bx, mstart
    mov al, cs:[bx]
    mov ah, 0
    int 10h
    iret

setpixel:
    mov ah, 0ch
    mov al, bl
    xor bh, bh
    int 10h
    iret

getpixel:
    mov ah, 0dh
    xor bh, bh
    int 10h
    mov bl, al
    mov bh, 0
    iret

retmode:
            cmp cl, 0
            jnz retmodea
            mov ax, 320     ; Mode 4
            mov bx, 200
            mov cx, 2
             iret
retmodea:   
            cmp cl, 1       ; Mode 15
            jnz retmodeb
            mov ax, 640
            mov bx, 350
            mov cx, 1
            iret
retmodeb:   
            cmp cl, 2       ; Mode 6
            jnz retmodec
            mov ax, 640
            mov bx, 200
            mov cx, 1
            iret
retmodec:   
            cmp cl, 3       ; Mode 14
            jnz retmoded
            mov ax, 640
            mov bx, 200
            mov cx, 4
            iret
retmoded:
            cmp cl, 4       ; Mode 16
            jnz retmodee
            mov ax, 640
            mov bx, 350
            mov cx, 4
            iret
retmodee:
            cmp cl, 5       ; Mode 17
            jnz retmodef
            mov ax, 640
            mov bx, 480
            mov cx, 1
            iret
retmodef:
            cmp cl, 6       ; Mode 18
            jnz retmodeg
            mov ax, 640
            mov bx, 480
            mov cx, 4
            iret
retmodeg:
            cmp cl, 7       ; Mode 19
            jnz retmodeh
            mov ax, 320
            mov bx, 200
            mov cx, 8
retmodeh:   iret

mstart:
        db 4,15,6,14,16,17,18,19
mydrvid db 0

nop
startme:
        mov ax, [02ch]          ; Get enviroment
        mov es, ax
        mov ah, 49h             ; Free...
        int 21h                 ; ...memory

    mov ax, 35FDh
    int 21h
    mov ax, es
    mov [retjmp+1], bx
    mov [retjmp+3], ax

    mov ax, 25FDh
    mov dx, dstrt
    int 21h

    mov ax, 35FEh
    int 21h
    mov ax, es:[bx]
    mov [mydrvid], al

    mov dx, startme
    int 27h
