    jmp startme
dstrt:
    cmp ah, cs:[mydrvid]
    jnz retjmp

    cmp al, 0
    jz retdata
    cmp al, 4
    jbe mousefkt
    cmp al, 5
    jz setcursor

    cmp al, 0FFh
    jz freemem

    mov ax, 0FFFFh
    mov bx, 0FFFFh
    mov cx, 0FFFFh
    mov dx, 0FFFFh
    iret

retdata:
    xor ax, ax          ; Check
    int 33h
    cmp ax, 0
;    jnz nomouse         ; Invalid -> NO MOUSE

    mov cx, 3210h
    mov ah, 1
    mov dl, 0
    iret

;nomouse:
;    mov ah, 0FFh        ; I'm not a mousedriver - I'm a stupid nothing-driver
;    iret

mousefkt:
    ; Nice: Fkt.1-4 has exactly the same use like in
    ;       the DOS-mousedriver.
    mov ah, 0
    int 33h
    iret

setcursor:
    mov ax, 9
    int 33h
    iret

retjmp: jmp 0FFFFh:0000h

freemem:

    mov ax, cs
    xor bx, bx
    xor cx, cx
    xor dx, dx
    mov si, 1234h
    iret

mydrvid db 0

nop
startme:
        mov ax, [02ch]          ; Get enviroment
        mov es, ax
        mov ah, 49h             ; Free...
        int 21h                 ; ...memory

    mov ax, 35FDh
    int 21h
    mov ax, es
    mov [retjmp+1], bx
    mov [retjmp+3], ax

    mov ax, 25FDh
    mov dx, dstrt
    int 21h

    mov ax, 35FEh
    int 21h
    mov ax, es:[bx]
    mov [mydrvid], al

    mov dx, startme
    int 27h
